#include <iostream>
#include<fstream>
using namespace std;

int main()
{
    int n,tt;
    int m[10000][10000];
    int sa=0,sb=0,sc=0,sd=0,se=0,sf=0;
    ifstream fi("MATRANVUONG.inp");
    fi>>n;
    ofstream fo("MATRANVUONG.out");
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            fi>>m[i][j];
        }
    }
    fi.close();
    for(int y=0;y<n;y++)
    {
        sa=sa+m[y][y];
        sb=sb+m[y][n+1-y];
        sc=sc+m[y][y+1];
        sc=sc+m[y][y-1];
        sd=sd+m[y][n+2-y];
        sd=sd+m[y][n-y];
    }
    for(int u=0;u<n;u++)
    {
        for(int v=0;v<n;v++)
        {
        	tt=n+1-u;
        	if(u>tt)
        	{
        		sf=sf+m[u][tt];
			}
            if(u<v)
            {
                se=se+m[u][v];
            }
        }
    }
    fo<<sa<<endl;
    fo<<sb<<endl;
    fo<<sc<<endl;
    fo<<sd<<endl;
    fo<<se<<endl;
    fo<<sf<<endl;
    fo.close();
    return 0;
}

